import { Disposable, DisposableCollection } from '@theia/core/lib/common/disposable';
import { MonacoIconRegistry } from '@theia/monaco/lib/browser/monaco-icon-registry';
import { IconContribution, DeployedPlugin, IconDefinition } from '../../common/plugin-protocol';
import { IThemeService } from '@theia/monaco-editor-core/esm/vs/platform/theme/common/themeService';
export declare class PluginIconService implements Disposable {
    protected readonly iconRegistry: MonacoIconRegistry;
    protected readonly toDispose: DisposableCollection;
    styleSheet: string;
    styleElement: HTMLStyleElement;
    register(contribution: IconContribution, plugin: DeployedPlugin): Disposable;
    updateStyle(contribution: IconContribution): void;
    dispose(): void;
    protected registerFontIcon(contribution: IconContribution, defaultIcon: IconDefinition): void;
    protected registerRegularIcon(contribution: IconContribution, defaultIconId: string): void;
    protected updateStyleElement(): void;
    protected getCSS(iconContribution: IconContribution, themeService?: IThemeService): string | undefined;
    protected toPluginUrl(id: string, relativePath: string): string;
    protected formatExtensionId(id: string): string;
}
//# sourceMappingURL=plugin-icon-service.d.ts.map